#ifndef GADAPTIVITY_H
#define GADAPTIVITY_H

#include <stdio.h>
class gtopology;
struct ivector;
struct matrix;
struct vector;

void give_der_star (vector &bf,double *rderfull,ivector &nodes,vector &der_star,long nn);
void ntnmtov (matrix &ntnm,vector &ntnv);
void print_contoures (gtopology *gt,char *file,double **midpoints,double *valel);
void print_confile (const char *file,long nnod,long nel,double **auxxyzv,long **auxnod,long dim);

void fprintf_matrix (FILE *stream, matrix &mx, char s[]);
void fprintf_vector (FILE *stream,vector &v,char s[],long c);
void fprintf_ivector (FILE *stream,ivector &v,char s[],long c);

void fprintf_d_1D (FILE *stream,double *p,long p_n,char s[],long c);
void fprintf_l_1D (FILE *stream,long *p,long p_n,char s[],long c);
void fprintf_l_2D (FILE *stream,long **p,long p_n,long p_m,char s[],long c);

long edge_position (gtopology *gt,long node1,long node2);
long surface_position (gtopology *gt,long node1,long node2,long node3);

long adjelem2edge (gtopology *gt,long node1,long node2,long eid);

long opposite_node (gtopology *gt,long *nod,long eid);

//long common_numbers (long n1,long *p1,long n2,long *p2);

#endif
